header:
// cartridge header
    dc.l    0xABCDEF42      // magic
    dc.l    0               // next 
    dc.l    0               // init
    dc.l    0xFA0000+prgstart // run
    dc.w    0               // time
    dc.w    0               // date
    dc.l    prgend-prgstart // size
    .asciz  "PSGTIMES.TOS"

.even
prgstart:

    pea     0.w
    move.w  #32,-(sp)   // Super
    trap    #1
    addq.l  #6,sp

    lea     0xffff8800.w,a1
    moveq   #15,d1
    move.l  #29999,d2   // 30000 repetitions

    move.l  0x4ba.w,d4  // hz200

again:
    move    sr,d3
    move    #0x2700,sr

    // 64 accesses
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)

    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)

    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    move.b  d1,(a1)
    
    move    d3,sr
    dbra    d2,again
    
    // calculate 200 hz ticks taken
    move.l  0x4ba.w,d3
    sub.l   d4,d3

    move.l  d0,-(sp)
    move.w  #32,-(sp)   // Super
    trap    #1
    addq.l  #6,sp

    // print ticks in D3
    divu.w  #100,d3
    move.w  d3,d0
    jbsr    printdigit
    clr.w   d3
    swap    d3
    divu.w  #10,d3
    move.w  d3,d0
    jbsr    printdigit
    swap    d3
    move.w  d3,d0
    jbsr    printdigit

    move.w  #1,-(sp)    // Cconin
    trap    #1
    addq.l  #2,sp

    move.w  #0,-(sp)    // Pterm0
    trap    #1

printdigit:
    add.w   #'0',d0
    move.w  d0,-(sp)
    move.w  #2,-(sp)    // Cconout
    trap    #1
    addq.l  #4,sp
    rts

prgend:

.fill 65536-(.-header)